﻿using UniversityContracts.BindingModels;
using UniversityContracts.ViewModels;
using UniversityDataModels.Models;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;

namespace UniversityDatabaseImplement.Models
{
    public class Activity : IActivityModel
    {
        public int Id { get; set; }
        [Required]
        public DateTime Date { get; set; }
        [Required]
        public int Number { get; set; }
        [ForeignKey("ActivityId")]
        public virtual List<ReportTypeActivity> ReportTypeActivities { get; set; } = new();

        public static Activity Create(ActivityBindingModel model)
        {
            return new Activity
            {
                Id = model.Id,
                Date = model.Date,
                Number = model.Number
            };
        }

        public void Update(ActivityBindingModel model)
        {
            if (model == null) return;

            Id = model.Id;
            Date = model.Date;
            Number = model.Number;
        }

        public ActivityViewModel GetViewModel => new()
        {
            Id = Id,
            Date = Date,
            Number = Number
        };
    }
}
